#include <stdio.h>
#ifndef USE_STDIO
#include <unistd.h>
#endif

#ifndef USE_STDIO
int instrumentation_fd=1;
#endif

enum { CACHE_LINE_LOGSIZE = 6, /* Pentium 4 uses, for dcache, 64-byte cache lines with a 8KB primary cache. */
       CACHE_LINE_SIZE = 1<<CACHE_LINE_LOGSIZE };

inline int cache_line_number(void *ptr) {
    int ptr_i = (int)ptr;
    return ptr_i>>CACHE_LINE_LOGSIZE;
}

extern void __c2c_ProfileRead(void*ptr, int size) {
    int base=cache_line_number(ptr);
    for (; size>0; size=-CACHE_LINE_SIZE, base++) {
#ifdef USE_STDIO
	printf("R%08x\n", base);
#else
	char buf[100];
	int n = snprintf(buf, 99, "R%08x\n", base);
	write(instrumentation_fd, buf, n);
#endif
    }
}
extern void __c2c_ProfileWrite(void*ptr, int size) {
    int base=cache_line_number(ptr);
    for (; size>0; size=-CACHE_LINE_SIZE, base++) {
#ifdef USE_STDIO
	printf("W%08x\n", base);
#else
	char buf[100];
	int n = snprintf(buf, 99, "W%08x\n", base);
	write(instrumentation_fd, buf, n);
#endif
    }
}
